//
// If you have improvements let my now at
//         gmsubelack@zonnet.nl
//
// Have funn.
//
// G.M. Subelack.
//

Unit VuUnit;

Interface

Uses
  Windows, SysUtils, Classes, Graphics, Controls, Forms,
  StdCtrls, Dialogs, ExtCtrls, ComCtrls, mmSystem, MPlayer,
  Gauges, VuMeter;

  Type
  TVuForm = Class(TForm)
    Image1: TImage;
    CloseBtn: TLabel;
    MoveLabel: TLabel;
    OpenBtn: TLabel;
    VolumeBar: TTrackBar;

    Meter1: TGauge;
    Meter2: TGauge;
    PaintBox: TPaintBox;
    VuMeter1: TVuMeter;
    OpenDialog: TOpenDialog;
//  *************************** Begin **********************************
    Procedure DrawGrid;
    Procedure DrawShow;
    Procedure DrawSpec;
    Procedure DrawScope1;
    Procedure DrawScope2;
    procedure VuMeter1BufferFilled(Buffer: PChar; var Size: Integer;
              Sender: TObject);
    Procedure VuMeter1VuInput(ChLeft, ChRight: Real; Sender: TObject);
    Procedure PaintBoxClick(Sender: TObject);
//  *************************** End **********************************
    Procedure CloseBtnClick(Sender: TObject);
    Procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
              Shift: TShiftState; X, Y: Integer);
    Procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,
              Y: Integer);
    Procedure OpenBtnClick(Sender: TObject);
    Procedure VolumeBarChange(Sender: TObject);
    Procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  Private
    { Private declarations }
    GridSize    : Integer;
    Scoop       : Integer;
    BuffL    : Array [0..4096] Of Single;
    BuffR    : Array [0..4096] Of Single;
    SPBufferL : Array [0..1024] Of Integer;
    SPBufferR : Array [0..1024] Of Integer;
    MediaPlayer           : TMediaPlayer;
    BitMap                : TBitMap;
    XPos                  : Integer;
    YPos                  : Integer;
    pCurrentVolumeLevel   : PDWord;
    CurrentVolumeLevel    : DWord;
    VolumeControlHandle   : hWnd;
  Public
    { Public declarations }
  end;

Var
  VuForm : TVuForm;
Implementation

{$R *.DFM}

// ******************* Begin Demo ******************
Procedure TVuForm.DrawGrid;
Var
I : Integer;
Begin
With BitMap.Canvas Do
begin
BitMap.Width := PaintBox.Width;
BitMap.Height := PaintBox.Height;
Brush.Color := clBlack;
Brush.Style := bsSolid;
FillRect(ClipRect);

// Grid Horizontal.
I := 0;
Repeat
MoveTo(0,I);
Pen.Color := clGreen;
LineTo(PaintBox.Width, I);

Inc(I,GridSize);
Until I >= PaintBox.Height;

// Grid Vertical.
I := 0;
Repeat
MoveTo(I,0);
LineTo(I, PaintBox.Height);
Inc(I,GridSize);
Until I >= PaintBox.Width;
end;
end;

Procedure TVuForm.DrawShow;
Var
I, N1, Y : Integer;
Begin
PaintBox.Hint := 'Show';
BitMap := TBitMap.Create;
Y := PaintBox.Height;

With BitMap.Canvas Do
Begin
BitMap.Width := PaintBox.Width;
BitMap.Height := PaintBox.Height;
Brush.Color := clBlack;
Brush.Style := bsSolid;
FillRect(ClipRect);

I := 0;
Repeat
N1 := PaintBox.Height Div 2 - Round(((BuffL[I] + BuffR[I]) * Y *2));
Pen.Color := 65535 -(N1 *300);
Ellipse(PaintBox.Width -N1, PaintBox.Height -N1,N1,N1);
Inc(I);
Until I >= 15;
PaintBox.Canvas.Draw(0,0,Bitmap);
BitMap.Free;
end;
end;

Procedure TVuForm.DrawSpec;    // Spectrum
Var
I,X,Y  : Integer;
Begin
PaintBox.Hint := 'Spectrum';
BitMap := TBitMap.Create;
Y := PaintBox.Height Div 4;
GridSize := 8;
DrawGrid;

X := 0;
For I := 0 To 1024 Do
If (BuffL[I]*10  >0) And (BuffL[I +1]*10 <0.001) Then  // Trigger pos. Left Channel
Inc(X);
If SPBufferL[X] < PaintBox.Height Then
Inc(SPBufferL[X], 22);

X := 0;
For I := 0 To 1024 Do
If (BuffR[I]*10  >0) And (BuffR[I +1]*10 <0.001) Then // Trigger pos. Rigth Channel
Inc(X);
If SPBufferL[X] < PaintBox.Height Then
Inc(SPBufferR[X], 22);

// Draw
With BitMap.Canvas Do
begin
Pen.Width := 1;

For I := 1 To PaintBox.Width Div 2 Do
Begin
Pen.Color := clLime;  // Left Channel
MoveTo(I *2,(Y *4)+1);
LineTo(I *2,(Y *4)-SPBufferL[I]);

Pen.Color := clRed;  // Rigth Channel
MoveTo((I *2)+1,(Y *4)+1);
LineTo((I *2)+1,(Y *4)-SPBufferR[I]);

If SPBufferL[I] >=0 Then
Dec(SPBufferL[I],2);
If SPBufferR[I] >=0 Then
Dec(SPBufferR[I],2);
end;

PaintBox.Canvas.Draw(0,0,Bitmap);
end;
BitMap.Free;
end;


Procedure TVuForm.DrawScope1;    // Normal Scope
Var
I, X, Y,L,R,T : Integer;
Trigger1 : Real;
Trigger2 : Real;
Begin
PaintBox.Hint := 'Normal Scope';
BitMap := TBitMap.Create;
Y := PaintBox.Height Div 4;
GridSize := 8;
DrawGrid;

With BitMap.Canvas Do
begin
// Red Line.
MoveTo(0,Y *2);
Pen.Color := clRed;
LineTo(BitMap.Width, Y *2);

L := Y;
R := 3* Y;
X := -1;

// Trigger Left
I := 0;
Repeat
Inc(I);
Trigger1 := BuffL[I] * 10;
Trigger2 := BuffL[I+1] * 10;
If Trigger2 > Trigger1 Then  // Trigger pos.
Trigger1 := -1;
Until (I >= 1024) Or ((Trigger1 >-0.9) And (Trigger1 <= 0.05));

T := I; // Trigger point
Pen.Color := clYellow;

MoveTo(X,L);
If 256 -I > PaintBox.Width Then
Begin
// Draw Buffer.
Repeat // Left Channel
Inc(X);
Inc(I);
LineTo(X,Y +Round(BuffL[I] * Y));
Until (X >= PaintBox.Width) Or (I >= 2048);

I := T; // Trigger point
X := -1;
MoveTo(X,R);
If 256 -I > PaintBox.Width Then
Repeat // Rigth Channel
Inc(X);
Inc(I);
LineTo(X,Y*3 +Round(BuffR[I] * Y));
Until (X >= PaintBox.Width) Or (I >= 2048);

PaintBox.Canvas.Draw(0,0,Bitmap);
end;
BitMap.Free;
end;
end;

Procedure TVuForm.DrawScope2;   // Filed Scope
Var
I,X,Y     : Integer;
N         : Real;
Trigger1  : Real;
Trigger2  : Real;
Begin
PaintBox.Hint := 'Filed Scope';
BitMap := TBitMap.Create;
Y := PaintBox.Height Div 4;
GridSize := 8;
DrawGrid;

With BitMap.Canvas Do
begin
// Yellow Line.
MoveTo(0,Y *2);
Pen.Color := clYellow;
LineTo(BitMap.Width, Y *2);

// Trigger
I := 0;
Repeat
Inc(I);
Trigger1 := BuffL[I] * 10;
Trigger2 := BuffL[I+1] * 10;
If Trigger2 > Trigger1 Then  // Trigger pos.
Trigger1 := -1;
Until (I >= 1024) Or ((Trigger1 >-0.9) And (Trigger1 <= 0.05));

X := 0;
If 256 -I > PaintBox.Width Then
Begin
Repeat
MoveTo(X ,Y);
// Draw Buffer Left.
N := Round(BuffL[I] * Y *2);
// Left Channel
MoveTo(X,Y +Round(N / 2));
Pen.Color := clLime;
LineTo(X,Y -Round(N / 2));

// Draw Buffer Rigth.
N := Round(BuffR[I] * Y *2);
// Rigth Channel
MoveTo(X,Y *3 +Round(N / 2));
Pen.Color := clRed;
LineTo(X,Y *3 -Round(N / 2));

Inc(X);
Inc(I);
Until (X >= PaintBox.Width) Or (I >= 1024);
PaintBox.Canvas.Draw(0,0,Bitmap);
end;
BitMap.Free;
end;
end;

Procedure TVuForm.PaintBoxClick(Sender: TObject);
Begin
Inc(Scoop);  // Select Scope type
If Scoop = 4 Then
Scoop := 0;
end;

Procedure TVuForm.VuMeter1BufferFilled(Buffer: PChar; Var Size: Integer;
          Sender: TObject);
Type
 PSample = ^SmallInt;
Var
I : Integer;
P : PSample;
Begin
  P := PSample(Buffer); // 8192
  For I := 0 To (4096 Div 2) -2 Do
  Begin
  BuffL[I] := (P^ / 32767);
  Inc(P);
  BuffR[I] := (P^ / 32767);
  Inc(P);
 end;
end;

Procedure TVuForm.VuMeter1VuInput(ChLeft, ChRight: Real; Sender: TObject);
Begin
Meter1.Progress := Round(100 * ChLeft);
Meter2.Progress := Round(100 * ChRight);
 If VuForm.Scoop =0 Then
 DrawSpec;
 If VuForm.Scoop =1 Then
 DrawScope1;
 If VuForm.Scoop =2 Then
 DrawScope2;
 If VuForm.Scoop =3 Then
 DrawShow;
end;


// ******************* End Demo ******************
Procedure TVuForm.CloseBtnClick(Sender: TObject);
Begin
Close;
end;

Procedure TVuForm.FormMouseDown(Sender: TObject; Button: TMouseButton;
          Shift: TShiftState; X, Y: Integer);
Begin
If ssLeft In Shift Then
Begin
XPos := X;
YPos := Y;
end;
end;

Procedure TVuForm.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
          Y: Integer);
Begin
If (ssLeft In Shift) Then
Begin
Left := (Left - XPos) + X;
Top := (Top - YPos) + Y;
end;
end;

Procedure TVuForm.OpenBtnClick(Sender: TObject);
Begin
If OpenDialog.Execute Then
Begin
MediaPlayer.FileName := OpenDialog.FileName;
MediaPlayer.Open;
MediaPlayer.Play;
end;
end;

Procedure TVuForm.VolumeBarChange(Sender: TObject);
Begin
  CurrentVolumeLevel := VolumeBar.Position * (65535 Div VolumeBar.Max) Shl 16;
  CurrentVolumeLevel := CurrentVolumeLevel + (VolumeBar.Position * (65535 Div VolumeBar.Max));
  WaveOutSetVolume(VolumeControlHandle, CurrentVolumeLevel);
end;

Procedure TVuForm.FormCreate(Sender: TObject);
Begin
MediaPlayer := TMediaPlayer.Create(Self);
MediaPlayer.Parent := Self;
MediaPlayer.Visible := False;

  New(pCurrentVolumeLevel);
  VolumeControlHandle := FindWindow('Volume Control', Nil);
  WaveOutGetVolume(VolumeControlHandle, pCurrentVolumeLevel);
  CurrentVolumeLevel := pCurrentVolumeLevel^;
  VolumeBar.Position := LoWord(CurrentVolumeLevel) Div (65535 Div VolumeBar.Max);
end;

Procedure TVuForm.FormDestroy(Sender: TObject);
Begin
MediaPlayer.Free;
end;

end.
